"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.insertDeviceIfDoesNotExist = void 0;
const insert_device_1 = require("./insert-device");
function insertDeviceIfDoesNotExist(param) {
    return __awaiter(this, void 0, void 0, function* () {
        const { deep, deviceLinkId, onInit, info, containerLinkId, } = param;
        if (deviceLinkId) {
            const { data: deviceLinks } = yield deep.select(deviceLinkId);
            if (deviceLinks.length === 0) {
                onInit(undefined);
                return { deviceLinkId: undefined };
            }
        }
        else {
            const { deviceLink } = yield (0, insert_device_1.insertDevice)({
                deep,
                info,
                containerLinkId,
            });
            onInit(deviceLink.id);
            return { deviceLinkId: deviceLink.id };
        }
    });
}
exports.insertDeviceIfDoesNotExist = insertDeviceIfDoesNotExist;
