"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.insertTerminalKey = void 0;
const gql_1 = require("@deep-foundation/deeplinks/imports/gql");
const package_name_1 = require("./package-name");
function insertTerminalKey(arg) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const { deep } = arg;
        const containTypeLinkId = yield deep.id('@deep-foundation/core', 'Contain');
        const containerLinkId = (_a = arg.containerLinkId) !== null && _a !== void 0 ? _a : deep.linkId;
        const reservedLinkIds = yield deep.reserve(1);
        const terminalKeyLinkId = reservedLinkIds.pop();
        return yield deep.serial({
            operations: [
                (0, gql_1.createSerialOperation)({
                    table: 'links',
                    type: 'insert',
                    objects: {
                        id: terminalKeyLinkId,
                        type_id: yield deep.id(package_name_1.PACKAGE_NAME, 'TerminalKey'),
                        in: {
                            data: {
                                type_id: containTypeLinkId,
                                from_id: containerLinkId,
                            },
                        },
                    },
                }),
                (0, gql_1.createSerialOperation)({
                    table: 'strings',
                    type: 'insert',
                    objects: {
                        link_id: terminalKeyLinkId,
                        value: arg.terminalKey,
                    },
                }),
            ],
        });
    });
}
exports.insertTerminalKey = insertTerminalKey;
