"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useArePackagesInstalled = void 0;
const client_1 = require("@deep-foundation/deeplinks/imports/client");
const react_1 = require("react");
function useArePackagesInstalled(param) {
    const { packageNames, shouldIgnoreResultWhenLoading = false, onError } = param;
    const [packageInstallationStatuses, setPackageInstallationStatuses] = (0, react_1.useState)(undefined);
    const { data, loading, error } = (0, client_1.useDeepSubscription)({
        type_id: {
            _id: ['@deep-foundation/core', 'Package'],
        },
        string: {
            value: {
                _in: packageNames
            },
        },
    });
    (0, react_1.useEffect)(() => {
        if (shouldIgnoreResultWhenLoading && loading) {
            return;
        }
        if (error) {
            onError === null || onError === void 0 ? void 0 : onError({ error });
            setPackageInstallationStatuses(undefined);
            return;
        }
        let packageInstallationStatuses = {};
        packageInstallationStatuses = packageNames.reduce((packageInstallationStatuses, packageName) => {
            packageInstallationStatuses[packageName] = !!(data && data.find(item => { var _a; return ((_a = item.value) === null || _a === void 0 ? void 0 : _a.value) === packageName; }));
            return packageInstallationStatuses;
        }, packageInstallationStatuses);
        setPackageInstallationStatuses(packageInstallationStatuses);
    }, [data, loading, error]);
    return { packageInstallationStatuses, loading, error };
}
exports.useArePackagesInstalled = useArePackagesInstalled;
